<link rel="import" href="../polymer/polymer-element.html">
<link rel="import" href="../iron-list/iron-list.html">
<link rel="import" href="../paper-item/paper-icon-item.html">
<link rel="import" href="../iron-icon/iron-icon.html">
<link rel="import" href="../iron-icons/iron-icons.html">
<link rel="import" href="../paper-icon-button/paper-icon-button.html">
<link rel="import" href="../paper-dialog/paper-dialog.html">
<link rel="import" href="../fotosocial-users-dm/fotosocial-users-dm.html">
<link rel="import" href="../fotosocial-new-post/fotosocial-new-post.html">
<link rel="import" href="../fotosocial-new-post-dm/fotosocial-new-post-dm.html">
<link rel="import" href="../fotosocial-posts-container/fotosocial-posts-container.html">
<link rel="import" href="../fotosocial-get-user-posts-dm/fotosocial-get-user-posts-dm.html">
<link rel="import" href="../fotosocial-update-post-dm/fotosocial-update-post-dm.html">

<dom-module id="fotosocial-dashboard">
  <template>
    <style>
      :host {
        display: block;
      }
      .header {
        display: flex;
        justify-content: space-between;
        align-items: center;
        margin: 10px;
        padding: 10px;
        border: 1px solid;
        background-color: #F2F2F2;
      }
      .main {
        display: flex;
        width: 100%;
      }

      .users-list {
        display: flex;
        flex-direction: column;
        width: 150px;
        margin: 10px;
        padding: 10px;
        border: 1px solid;
        background-color: #F2F2F2;
      }
      .posts {
        width: calc( 100% - 150px);
        margin: 10px;
        padding: 10px;
        border: 1px solid;
        background-color: #F2F2F2;
      }

    </style>
    <div class="header">
      <img src="./src/img/fotosocial.png" width="168" height="40"/>
      <div>Usuario: [[user]] <paper-icon-button icon="close" on-click="_logout"></paper-icon-button></div>
    </div>
    <div class="main">
      <div class="users-list">
        <fotosocial-users-dm id="usersDm"></fotosocial-users-dm>
        <paper-icon-item id="[[user]]" on-click="_userSelect">
          <iron-icon icon="account-circle" slot="item-icon"></iron-icon>
          [[user]]
        </paper-icon-item>
        <iron-list items="[[userFriends]]" as="friend">
          <template>
            <paper-icon-item id="[[friend]]" on-click="_userSelect">
              <iron-icon icon="account-circle" slot="item-icon"></iron-icon>
              [[friend]]
            </paper-icon-item>
          </template>
        </iron-list>
      </div>
      <div class="posts">
        <fotosocial-posts-container on-post-like-unlike="_postLikeUnlike" posts="[[userSelectedPosts]]"></fotosocial-posts-container>
        <paper-icon-button hidden$="[[!userEqualSelect]]" icon="add-circle" on-click="_callNewPost"></paper-icon-button>
      </div>
    </div>
    <paper-dialog id="modalNewPost" modal>
      <fotosocial-new-post on-save-post="_savePost"></fotosocial-new-post>
      <div class="buttons">
        <paper-button dialog-confirm autofocus>Cancelar</paper-button>
      </div>
    </paper-dialog>
    <fotosocial-new-post-dm id="newPostDm" on-add-post-success="_addPostSuccess"></fotosocial-new-post-dm>
    <fotosocial-get-user-posts-dm on-user-posts="_displayUserSelectedPosts" id="getUserPostsDm"></fotosocial-get-user-posts-dm>
    <fotosocial-update-post-dm on-like-unlike-success="_likeUnlikeSuccess" id="updatePostDm"></fotosocial-update-post-dm>
  </template>

  <script>
    /**
     * `fotosocial-dashboard`
     * dashboard del proyecto
     *
     * @customElement
     * @polymer
     * @demo demo/index.html
     */
    class FotosocialDashboard extends Polymer.Element {
      static get is() { return 'fotosocial-dashboard'; }
      static get properties() {
        return {
          user: {
            type: String,
            value: '',
            observer: '_userChanged'
          },
          users: {
            type: Array,
            value: []
          },
          userFriends: {
            type: Array,
            value: [],
            computed: '_getUserFriends(user, users)'
          },
          userEqualSelect: {
            type: Boolean,
            value: true
          },
          userSelected: {
            type: String,
            value: ''
          },
          userSelectedPosts: {
            type: Array,
            value: []
          }
        };
      }

      _userChanged(e) {
        if (e !== '') {
          this.set('users', this.$.usersDm.getUsers());
          this.set('userSelected', this.user);
          this.$.getUserPostsDm.getUserPosts(this.user);
          this.set('userEqualSelect', true);
        }
      }

      _getUserFriends(user, users) {
        return users.filter(el => el !== user);
      }

      _callNewPost() {
        this.$.modalNewPost.open();
      }

      _savePost(post) {
        this.shadowRoot.querySelector('#newPostDm').set('user', this.user);
        this.shadowRoot.querySelector('#newPostDm').set('photo',post.detail.photo);
        this.shadowRoot.querySelector('#newPostDm').set('description',post.detail.description);
        this.$.newPostDm.savePost();
      }
  
      _addPostSuccess() {
        this.$.getUserPostsDm.getUserPosts(this.userSelected);
        this.$.modalNewPost.close();
      }
  
      _userSelect(e) {
        this.set('userEqualSelect', e.target.id === this.user);
        this.set('userSelected', e.target.id);
        // llamar datamanager que devolvera los post del usuario enviado
        this.$.getUserPostsDm.getUserPosts(this.userSelected);
      }

      _displayUserSelectedPosts(e) {
        // probar evento del local storage para volver a setear la propiedad
        this.set('userSelectedPosts', e.detail)
      }

      _postLikeUnlike(e) {
        this.$.updatePostDm.updateLikesUnlikes(this.user,this.userSelected,e.detail);
      }

      _likeUnlikeSuccess() {
        this.$.getUserPostsDm.getUserPosts(this.userSelected);
      }
  
      _logout() {
        this.set('user', '');
        this.dispatchEvent(new CustomEvent('log-out', {}));
      }
    }

    window.customElements.define(FotosocialDashboard.is, FotosocialDashboard);
  </script>
</dom-module>
